﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes
    #StartAtBoot: False
    #ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public BleMan As BleManager2
	Public RunPer As RuntimePermissions
	Public BytCon As ByteConverter
  
	Public SaveDeviceName As String
	Public SaveDeviceId As String
	Public SaveServiceId As String
	Public SaveCharacteristicId As String
  
	Public BleReadTimer As Timer
  
	Public DeviceIdStartsWith As String = "D3:CC:"
	Public ServiceIdStartsWith As String  = "0000ffe0"
	Public CharacteristicIdStartsWith As String = "0000ffe1"
	
	Public GetPer=False As Boolean
  
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	BleMan.Initialize("BleMan")
	BleReadTimer.Initialize("BleReadTimer", 123)    'will set interval when enable timer (ie 123 = don't care)
  
	If BleMan.State <> BleMan.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If RunPer.Check(RunPer.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
		GetPer=True
	Else
		Log("Let the games begin...")
		BleMan.Scan2(Null, False)    'set second parameter to True to see multiple/all scans per device
	End If
  
End Sub

Sub Service_Start (StartingIntent As Intent)
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
End Sub

'*** THE THREE HANDLERS FOR BLE EVENTS ***

Sub BleMan_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
  
	Log("Device = " & Id.Trim & " " & Name.Trim & " " & RSSI)
  
	If SaveDeviceId = "" Then    'if we haven't yet found the device we're looking for
		'If Id.StartsWith(DeviceIdStartsWith) Then    'and this one is it
		If Name.StartsWith("HC-08") Then    'and this one is it
			SaveDeviceId = Id    'then save it
			BleMan.Connect2(SaveDeviceId, False)    'and connect to it
          
			BleMan.StopScan    'this can be done anytime after the device-of-interest has been found and its id saved
		End If
	End If
End Sub

Sub BleMan_Connected (Services As List)
  
	Log("Connected")
      
	For Each S As String In Services
		Log("Service = " & S)
		If SaveServiceId = "" Then    'if we haven't yet found the service we're looking for
			If S.StartsWIth(ServiceIdStartsWith) Then    'and this one is it
				SaveServiceId = S    'then save it
				BleMan.ReadData(SaveServiceId)    'and read it
			End If
		End If
	Next
  
End Sub

Sub BleMan_DataAvailable (ServiceId As String, Characteristics As Map)
  
	Log("DataAvailable")
  
	For Each C As String In Characteristics.Keys
		Dim V() As Byte = Characteristics.Get(C)
		Log("Characteristic " & C & " = " & ByteArrayToAsciiString(V))
		
		If V.Length>1 Then
			CallSub2(Main,"RX",ByteArrayToAsciiString(V))
		End If
		
		If SaveCharacteristicId = "" Then    'if haven't yet found the characteristic we're looking for
			If ServiceId = SaveServiceId Then
				If C.StartsWith(CharacteristicIdStartsWith) Then    'and this one is it
					SaveCharacteristicId = C    'then save it (ServiceId already saved)
                   
					'if SetIndication doesn't work, then try SetNotify
					Dim Result As Boolean = BleMan.SetIndication(SaveServiceId, SaveCharacteristicId, True)
					Log("SetIndication " & Result)
                   
					'BleReadTimer.Interval = 10000    'and read it every 10 seconds
					'BleReadTimer.Enabled = True
				End If
			End If
		End If
	Next
  
End Sub

'*** TIMER DEMONSTRATING READDATA2 (RETURNS SPECIFIC CHARACTERISTIC, CF READDATA RETURNS ALL) ***

Sub BleReadTimer_Tick
  
	'SaveServiceId should have already been set in BleMan_Connected, before BleMan.ReadData was done
	'SaveCharacteristicId should have already been set in BleMan_DataAvailable, before this timer was enabled
  
	BleMan.ReadData2(SaveServiceId, SaveCharacteristicId)
      
End Sub

'*** AND LAST, BUT BY NO MEANS LEAST, A FUNCTION TO STOP ME GOING CROSS-EYED ***

Sub ByteArrayToAsciiString(BA() As Byte) As String
 
	Dim AsciiString As String = ""
	Dim Ch As Byte
 
	For I = 0 To BA.Length - 1
		Ch = BA(I)
   
		If Ch >= 32 And Ch <= 126 Then    'within byte range so no sign problem
			AsciiString = AsciiString & Chr(Ch)
		Else
			AsciiString = AsciiString & "."
		End If
	Next
 
	Return AsciiString
 
End Sub